commit 0b7bd5c227cd8c9d720bea2cb3363ece3d7b21e7
Author: freddy77 <freddy77>
Date:   Mon Dec 15 15:52:10 2008 +0000

    add and reuse tds_bcp_done, tds_bcp_start and tds_bcp_start_copy_in

diff --git a/ChangeLog b/ChangeLog
index 5e66c86..f5f4b5b 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Dec 15 16:48:44 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/ctlib/blk.c src/dblib/bcp.c src/tds/bulk.c:
+	- add and reuse tds_bcp_done, tds_bcp_start and tds_bcp_start_copy_in
+
 Mon Dec 15 14:18:38 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/ctlib/blk.c src/dblib/bcp.c src/tds/bulk.c:
 	- add and reuse tds_bcp_send_colmetadata
@@ -1069,4 +1073,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2681 2008/12/15 13:21:45 freddy77 Exp $
+$Id: ChangeLog,v 1.2682 2008/12/15 15:52:10 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index a25c018..025d154 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.306 2008/12/15 13:21:45 freddy77 Exp $ */
+/* $Id: tds.h,v 1.307 2008/12/15 15:52:10 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1614,9 +1614,10 @@ typedef struct tds_bcpinfo
 
 typedef int  (*tds_bcp_get_col_data) (TDSBCPINFO *bulk, TDSCOLUMN *bcpcol, int offset);
 typedef void (*tds_bcp_null_error)   (TDSBCPINFO *bulk, int index, int offset);
-int tds_bcp_start_insert_stmt(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 int tds_bcp_send_record(TDSSOCKET *tds, TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data, tds_bcp_null_error null_error, int offset);
-int tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
+int tds_bcp_done(TDSSOCKET *tds, int *rows_copied);
+int tds_bcp_start(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
+int tds_bcp_start_copy_in(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 
 
 #define IS_TDS42(x) (x->major_version==4 && x->minor_version==2)
diff --git a/src/ctlib/blk.c b/src/ctlib/blk.c
index 52939f0..6849b68 100644
--- a/src/ctlib/blk.c
+++ b/src/ctlib/blk.c
@@ -38,11 +38,10 @@
 #include "ctlib.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: blk.c,v 1.46 2008/12/15 13:21:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: blk.c,v 1.47 2008/12/15 15:52:10 freddy77 Exp $");
 
 static void _blk_null_error(TDSBCPINFO *bcpinfo, int index, int offset);
 static int _blk_get_col_data(TDSBCPINFO *bulk, TDSCOLUMN *bcpcol, int offset);
-static CS_RETCODE _rowxfer_in_init(CS_BLKDESC * blkdesc);
 static CS_RETCODE _blk_rowxfer_in(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred);
 static CS_RETCODE _blk_rowxfer_out(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred);
 
@@ -219,49 +218,35 @@ CS_RETCODE
 blk_done(CS_BLKDESC * blkdesc, CS_INT type, CS_INT * outrow)
 {
 	TDSSOCKET *tds;
+	int rows_copied;
 
 	tdsdump_log(TDS_DBG_FUNC, "blk_done()\n");
 	tds = blkdesc->con->tds_socket;
 
 	switch (type) {
 	case CS_BLK_BATCH:
-
-		tds_flush_packet(tds);
-		/* TODO correct ?? */
-		tds_set_state(tds, TDS_PENDING);
-		if (tds_process_simple_query(tds) != TDS_SUCCEED) {
+		if (tds_bcp_done(tds, &rows_copied) != TDS_SUCCEED) {
 			_ctclient_msg(blkdesc->con, "blk_done", 2, 5, 1, 140, "");
 			return CS_FAIL;
 		}
 		
 		if (outrow) 
-			*outrow = tds->rows_affected;
+			*outrow = rows_copied;
 		
-		tds_submit_query(tds, blkdesc->bcpinfo.insert_stmt);
-		if (tds_process_simple_query(tds) != TDS_SUCCEED) {
+		if (tds_bcp_start(tds, &blkdesc->bcpinfo) != TDS_SUCCEED) {
 			_ctclient_msg(blkdesc->con, "blk_done", 2, 5, 1, 140, "");
 			return CS_FAIL;
 		}
-
-		tds->out_flag = TDS_BULK;
-
-		if (IS_TDS7_PLUS(tds))
-			tds_bcp_send_colmetadata(tds, &blkdesc->bcpinfo);
-
 		break;
 		
 	case CS_BLK_ALL:
-
-		tds_flush_packet(tds);
-		/* TODO correct ?? */
-		tds_set_state(tds, TDS_PENDING);
-		if (tds_process_simple_query(tds) != TDS_SUCCEED) {
+		if (tds_bcp_done(tds, &rows_copied) != TDS_SUCCEED) {
 			_ctclient_msg(blkdesc->con, "blk_done", 2, 5, 1, 140, "");
 			return CS_FAIL;
 		}
 		
 		if (outrow) 
-			*outrow = tds->rows_affected;
+			*outrow = rows_copied;
 		
 		/* free allocated storage in blkdesc & initialise flags, etc. */
 	
@@ -697,15 +682,10 @@ _blk_rowxfer_in(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred
 		 * retrieve details of the database table columns
 		 */
 
-		if (_rowxfer_in_init(blkdesc) == CS_FAIL)
-			return (CS_FAIL);
-
-
-		/* set packet type to send bulk data */
-		tds->out_flag = TDS_BULK;
-
-		if (IS_TDS7_PLUS(tds))
-			tds_bcp_send_colmetadata(tds, &blkdesc->bcpinfo);
+		if (tds_bcp_start_copy_in(tds, &blkdesc->bcpinfo) == TDS_FAIL) {
+			_ctclient_msg(blkdesc->con, "blk_rowxfer", 2, 5, 1, 140, "");
+			return CS_FAIL;
+		}
 
 		blkdesc->bcpinfo.xfer_init = 1;
 	} 
@@ -721,100 +701,6 @@ _blk_rowxfer_in(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred
 	return CS_SUCCEED;
 }
 
-static CS_RETCODE
-_rowxfer_in_init(CS_BLKDESC * blkdesc)
-{
-
-	TDSSOCKET *tds = blkdesc->con->tds_socket;
-	TDSCOLUMN *bcpcol;
-
-	int i;
-
-	int fixed_col_len_tot     = 0;
-	int variable_col_len_tot  = 0;
-	int column_bcp_data_size  = 0;
-	int bcp_record_size       = 0;
-	
-	TDSBCPINFO *bcpinfo = &blkdesc->bcpinfo;
-
-	if (tds_bcp_start_insert_stmt(tds, bcpinfo) == TDS_FAIL)
-		return CS_FAIL;
-
-	/*
-	 * In TDS 5 we get the column information as a result set from the "insert bulk" command.
-	 * We're going to ignore it.  
-	 */
-	if (tds_process_simple_query(tds) != TDS_SUCCEED) {
-		_ctclient_msg(blkdesc->con, "blk_rowxfer", 2, 5, 1, 140, "");
-		return CS_FAIL;
-	}
-
-	/* FIXME find a better way, some other thread could change state here */
-	tds_set_state(tds, TDS_QUERYING);
-
-	/* 
-	 * Work out the number of "variable" columns.  These are either nullable or of 
-	 * varying length type e.g. varchar.   
-	 */
-	bcpinfo->var_cols = 0;
-
-	if (IS_TDS50(tds)) {
-		for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
-	
-			bcpcol = bcpinfo->bindinfo->columns[i];
-
-			/*
-			 * work out storage required for this datatype
-			 * blobs always require 16, numerics vary, the
-			 * rest can be taken from the server
-			 */
-
-			if (is_blob_type(bcpcol->on_server.column_type))
-				column_bcp_data_size  = 16;
-			else if (is_numeric_type(bcpcol->on_server.column_type))
-				column_bcp_data_size  = tds_numeric_bytes_per_prec[bcpcol->column_prec];
-			else
-				column_bcp_data_size  = bcpcol->column_size;
-
-			/*
-			 * now add that size into either fixed or variable
-			 * column totals...
-			 */
-
-			if (is_nullable_type(bcpcol->on_server.column_type) || bcpcol->column_nullable) {
-				bcpinfo->var_cols++;
-				variable_col_len_tot += column_bcp_data_size;
-			}
-			else {
-				fixed_col_len_tot += column_bcp_data_size;
-			}
-		}
-
-		/* this formula taken from sybase manual... */
-
-		bcp_record_size =  	4 +
-							fixed_col_len_tot +
-							variable_col_len_tot +
-							( (int)(variable_col_len_tot / 256 ) + 1 ) +
-							(bcpinfo->var_cols + 1) +
-							2;
-
-		tdsdump_log(TDS_DBG_FUNC, "current_record_size = %d\n", bcpinfo->bindinfo->row_size);
-		tdsdump_log(TDS_DBG_FUNC, "bcp_record_size     = %d\n", bcp_record_size);
-
-		if (bcp_record_size > bcpinfo->bindinfo->row_size) {
-			bcpinfo->bindinfo->current_row = realloc(bcpinfo->bindinfo->current_row, bcp_record_size);
-			if (bcpinfo->bindinfo->current_row == NULL) {
-				tdsdump_log(TDS_DBG_FUNC, "could not realloc current_row\n");
-				return CS_FAIL;
-			}
-			bcpinfo->bindinfo->row_size = bcp_record_size;
-		}
-	}
-
-	return CS_SUCCEED;
-}
-
 static void
 _blk_null_error(TDSBCPINFO *bcpinfo, int index, int offset)
 {
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index 85b5e31..a099b04 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -61,7 +61,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.176 2008/12/15 13:21:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.177 2008/12/15 15:52:10 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -82,8 +82,6 @@ static void _bcp_free_columns(DBPROCESS * dbproc);
 static void _bcp_null_error(TDSBCPINFO *bcpinfo, int index, int offset);
 static int _bcp_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset);
 static int _bcp_no_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset);
-static RETCODE _bcp_start_copy_in(DBPROCESS *);
-static RETCODE _bcp_start_new_batch(DBPROCESS *);
 
 static int rtrim(char *, int);
 static offset_type _bcp_measure_terminated_field(FILE * hostfile, BYTE * terminator, int term_len);
@@ -1621,18 +1619,11 @@ bcp_sendrow(DBPROCESS * dbproc)
 	if (dbproc->bcpinfo->xfer_init == 0) {
 
 		/* The start_copy function retrieves details of the table's columns */
-		if (_bcp_start_copy_in(dbproc) == FAIL) {
+		if (tds_bcp_start_copy_in(tds, dbproc->bcpinfo) == TDS_FAIL) {
 			dbperror(dbproc, SYBEBULKINSERT, 0);
-			return (FAIL);
+			return FAIL;
 		}
 
-		/* set packet type to send bulk data */
-		tds->out_flag = TDS_BULK;
-		tds_set_state(tds, TDS_QUERYING);
-
-		if (IS_TDS7_PLUS(tds))
-			tds_bcp_send_colmetadata(tds, dbproc->bcpinfo);
-
 		dbproc->bcpinfo->xfer_init = 1;
 
 	}
@@ -1677,17 +1668,11 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 		return FAIL;
 	}
 
-	if (_bcp_start_copy_in(dbproc) == FAIL) {
+	if (tds_bcp_start_copy_in(tds, dbproc->bcpinfo) == TDS_FAIL) {
 		fclose(hostfile);
 		return FAIL;
 	}
 
-	tds->out_flag = TDS_BULK;
-	tds_set_state(tds, TDS_QUERYING);
-
-	if (IS_TDS7_PLUS(tds))
-		tds_bcp_send_colmetadata(tds, dbproc->bcpinfo);
-
 	row_of_hostfile = 0;
 	rows_written_so_far = 0;
 
@@ -1778,25 +1763,19 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 					rows_written_so_far++;
 	
 					if (dbproc->hostfileinfo->batch > 0 && rows_written_so_far == dbproc->hostfileinfo->batch) {
-						rows_written_so_far = 0;
-	
-						tds_flush_packet(tds);
-	
-						tds_set_state(tds, TDS_PENDING);
-	
-						if (tds_process_simple_query(tds) != TDS_SUCCEED) {
+						if (tds_bcp_done(tds, &rows_written_so_far) != TDS_SUCCEED) {
 							if (errfile)
 								fclose(errfile);
 							fclose(hostfile);
 							return FAIL;
 						}
 							
-						*rows_copied += tds->rows_affected;
+						*rows_copied += rows_written_so_far;
+						rows_written_so_far = 0;
 	
 						dbperror(dbproc, SYBEBBCI, 0); /* batch copied to server */
 	
-						_bcp_start_new_batch(dbproc);
-	
+						tds_bcp_start(tds, dbproc->bcpinfo);
 					}
 				}
 			} else {
@@ -1822,15 +1801,8 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 		ret = FAIL;
 	}
 
-	tds_flush_packet(tds);
-
-	tds_set_state(tds, TDS_PENDING);
-
-	if (tds_process_simple_query(tds) != TDS_SUCCEED) {
-		return FAIL;
-	}
-	
-	*rows_copied += tds->rows_affected;
+	tds_bcp_done(tds, &rows_written_so_far);
+	*rows_copied += rows_written_so_far;
 
 	return ret == NO_MORE_ROWS? SUCCEED : FAIL;	/* (ret is returned from _bcp_read_hostfile) */
 }
@@ -1884,189 +1856,6 @@ bcp_row_free(TDSRESULTINFO* result, unsigned char *row)
  * \ingroup dblib_bcp_internal
  * \brief 
  *
- * \param dbproc contains all information needed by db-lib to manage communications with the server.
- * 
- * \return SUCCEED or FAIL.
- * \sa 	BCP_SETL(), bcp_batch(), bcp_bind(), bcp_colfmt(), bcp_colfmt_ps(), bcp_collen(), bcp_colptr(), bcp_columns(), bcp_control(), bcp_done(), bcp_exec(), bcp_getl(), bcp_init(), bcp_moretext(), bcp_options(), bcp_readfmt(), bcp_sendrow()
- */
-static RETCODE
-_bcp_start_copy_in(DBPROCESS * dbproc)
-{
-	TDSSOCKET *tds = dbproc->tds_socket;
-	TDSCOLUMN *bcpcol;
-	int i;
-	int fixed_col_len_tot     = 0;
-	int variable_col_len_tot  = 0;
-	int column_bcp_data_size  = 0;
-	int bcp_record_size       = 0;
-	TDSBCPINFO *bcpinfo;
-
-	tdsdump_log(TDS_DBG_FUNC, "_bcp_start_copy_in(%p)\n", dbproc);
-	assert(dbproc);
-	bcpinfo = dbproc->bcpinfo;
-
-	if (tds_bcp_start_insert_stmt(tds, bcpinfo) == TDS_FAIL)
-		return FAIL;
-
-	/*
-	 * In TDS 5 we get the column information as a result set from the "insert bulk" command.
-	 * We're going to ignore it.  
-	 */
-	if (tds_process_simple_query(tds) != TDS_SUCCEED)
-		return FAIL;
-
-	/* 
-	 * Work out the number of "variable" columns.  These are either nullable or of 
-	 * varying length type e.g. varchar.   
-	 */
-	bcpinfo->var_cols = 0;
-
-	if (IS_TDS50(tds)) {
-		for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
-	
-			bcpcol = bcpinfo->bindinfo->columns[i];
-
-			/*
-			 * work out storage required for this datatype
-			 * blobs always require 16, numerics vary, the
-			 * rest can be taken from the server
-			 */
-
-			if (is_blob_type(bcpcol->on_server.column_type))
-				column_bcp_data_size  = 16;
-			else if (is_numeric_type(bcpcol->on_server.column_type))
-				column_bcp_data_size  = tds_numeric_bytes_per_prec[bcpcol->column_prec];
-			else
-				column_bcp_data_size  = bcpcol->column_size;
-
-			/*
-			 * now add that size into either fixed or variable
-			 * column totals...
-			 */
-
-			if (is_nullable_type(bcpcol->on_server.column_type) || bcpcol->column_nullable) {
-				bcpinfo->var_cols++;
-				variable_col_len_tot += column_bcp_data_size;
-			}
-			else {
-				fixed_col_len_tot += column_bcp_data_size;
-			}
-		}
-
-		/* this formula taken from sybase manual... */
-
-		bcp_record_size =  	4 +
-							fixed_col_len_tot +
-							variable_col_len_tot +
-							( (int)(variable_col_len_tot / 256 ) + 1 ) +
-							(bcpinfo->var_cols + 1) +
-							2;
-
-		tdsdump_log(TDS_DBG_FUNC, "current_record_size = %d\n", bcpinfo->bindinfo->row_size);
-		tdsdump_log(TDS_DBG_FUNC, "bcp_record_size     = %d\n", bcp_record_size);
-
-		if (bcp_record_size > bcpinfo->bindinfo->row_size) {
-			/* FIXME remove memory leak */
-			bcpinfo->bindinfo->current_row = realloc(bcpinfo->bindinfo->current_row, bcp_record_size);
-			bcpinfo->bindinfo->row_free = bcp_row_free;
-			if (bcpinfo->bindinfo->current_row == NULL) {
-				tdsdump_log(TDS_DBG_FUNC, "could not realloc current_row\n");
-				return FAIL;
-			}
-			bcpinfo->bindinfo->row_size = bcp_record_size;
-		}
-	}
-	if (IS_TDS7_PLUS(tds)) {
-		for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
-	
-			bcpcol = bcpinfo->bindinfo->columns[i];
-
-			/*
-			 * dont send the (meta)data for timestamp columns, or
-			 * identity columns (unless indentity_insert is enabled
-			 */
-
-			if ((!bcpinfo->identity_insert_on && bcpcol->column_identity) || 
-				bcpcol->column_timestamp) {
-				continue;
-			}
-
-			switch (bcpcol->column_varint_size) {
-				case 4:
-					if (is_blob_type(bcpcol->column_type)) {
-						bcp_record_size += 25;
-					}
-					bcp_record_size += 4;
-					break;
-				case 2:
-					bcp_record_size +=2;
-					break;
-				case 1:
-					bcp_record_size++;
-					break;
-				case 0:
-					break;
-			}
-
-			if (is_numeric_type(bcpcol->column_type)) {
-				bcp_record_size += tds_numeric_bytes_per_prec[bcpcol->column_prec];
-			} else {
-				bcp_record_size += bcpcol->column_size;
-			}
-		}
-		tdsdump_log(TDS_DBG_FUNC, "current_record_size = %d\n", bcpinfo->bindinfo->row_size);
-		tdsdump_log(TDS_DBG_FUNC, "bcp_record_size     = %d\n", bcp_record_size);
-
-		if (bcp_record_size > bcpinfo->bindinfo->row_size) {
-			bcpinfo->bindinfo->current_row = realloc(bcpinfo->bindinfo->current_row, bcp_record_size);
-			bcpinfo->bindinfo->row_free = bcp_row_free;
-			if (bcpinfo->bindinfo->current_row == NULL) {
-				tdsdump_log(TDS_DBG_FUNC, "could not realloc current_row\n");
-				return FAIL;
-			}
-			bcpinfo->bindinfo->row_size = bcp_record_size;
-		}
-	}
-
-	return SUCCEED;
-}
-
-/** 
- * \ingroup dblib_bcp_internal
- * \brief 
- *
- * \param dbproc contains all information needed by db-lib to manage communications with the server.
- * 
- * \return SUCCEED or FAIL.
- * \sa 	BCP_SETL(), bcp_batch(), bcp_bind(), bcp_colfmt(), bcp_colfmt_ps(), bcp_collen(), bcp_colptr(), bcp_columns(), bcp_control(), bcp_done(), bcp_exec(), bcp_getl(), bcp_init(), bcp_moretext(), bcp_options(), bcp_readfmt(), bcp_sendrow()
- */
-static RETCODE
-_bcp_start_new_batch(DBPROCESS * dbproc)
-{
-	TDSSOCKET *tds = dbproc->tds_socket;
-
-	tdsdump_log(TDS_DBG_FUNC, "_bcp_start_new_batch(%p)\n", dbproc);
-	assert(dbproc);
-
-	tds_submit_query(tds, dbproc->bcpinfo->insert_stmt);
-
-	if (tds_process_simple_query(tds) != TDS_SUCCEED)
-		return FAIL;
-
-	/* TODO problem with thread safety */
-	tds->out_flag = TDS_BULK;
-	tds_set_state(tds, TDS_QUERYING);
-
-	if (IS_TDS7_PLUS(tds))
-		tds_bcp_send_colmetadata(tds, dbproc->bcpinfo);
-	
-	return SUCCEED;
-}
-
-/** 
- * \ingroup dblib_bcp_internal
- * \brief 
- *
  * \param buffer 
  * \param size 
  * \param f 
@@ -2442,7 +2231,6 @@ bcp_moretext(DBPROCESS * dbproc, DBINT size, BYTE * text)
 DBINT
 bcp_batch(DBPROCESS * dbproc)
 {
-	TDSSOCKET *tds;
 	int rows_copied = 0;
 
 	tdsdump_log(TDS_DBG_FUNC, "bcp_batch(%p)\n", dbproc);
@@ -2450,19 +2238,12 @@ bcp_batch(DBPROCESS * dbproc)
 	DBPERROR_RETURN(IS_TDSDEAD(dbproc->tds_socket), SYBEDDNE);
 	CHECK_PARAMETER(dbproc->bcpinfo, SYBEBCPI, FAIL);
 
-	tds = dbproc->tds_socket;
-	tds_flush_packet(tds);
-
-	tds_set_state(tds, TDS_PENDING);
-
-	if (tds_process_simple_query(tds) != TDS_SUCCEED)
+	if (tds_bcp_done(dbproc->tds_socket, &rows_copied) != TDS_SUCCEED)
 		return FAIL;
 
-	rows_copied = tds->rows_affected;
-
-	_bcp_start_new_batch(dbproc);
+	tds_bcp_start(dbproc->tds_socket, dbproc->bcpinfo);
 
-	return (rows_copied);
+	return rows_copied;
 }
 
 /** 
@@ -2478,29 +2259,19 @@ bcp_batch(DBPROCESS * dbproc)
 DBINT
 bcp_done(DBPROCESS * dbproc)
 {
-	TDSSOCKET *tds;
-	int rows_copied = -1;
+	int rows_copied;
 
 	tdsdump_log(TDS_DBG_FUNC, "bcp_done(%p)\n", dbproc);
 	CHECK_DBPROC();
 	DBPERROR_RETURN(IS_TDSDEAD(dbproc->tds_socket), SYBEDDNE);
 	CHECK_PARAMETER(dbproc->bcpinfo, SYBEBCPI, FAIL);
 
-	/* TODO check proper tds state */
-
-	tds = dbproc->tds_socket;
-	tds_flush_packet(tds);
-
-	tds_set_state(tds, TDS_PENDING);
-
-	if (tds_process_simple_query(tds) != TDS_SUCCEED)
-		return FAIL;
-		
-	rows_copied = tds->rows_affected;
+	if (tds_bcp_done(dbproc->tds_socket, &rows_copied) != TDS_SUCCEED)
+		return -1;
 
 	_bcp_free_storage(dbproc);
 
-	return (rows_copied);
+	return rows_copied;
 }
 
 /** 
diff --git a/src/tds/bulk.c b/src/tds/bulk.c
index 89f0b9a..397d7af 100644
--- a/src/tds/bulk.c
+++ b/src/tds/bulk.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: bulk.c,v 1.3 2008/12/15 13:21:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bulk.c,v 1.4 2008/12/15 15:52:10 freddy77 Exp $");
 
 typedef struct tds_pbcb
 {
@@ -51,6 +51,8 @@ typedef struct tds_pbcb
 	unsigned int from_malloc;
 } TDSPBCB;
 
+static int tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
+static int tds_bcp_start_insert_stmt(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 static int tds_bcp_add_fixed_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data, tds_bcp_null_error null_error, int offset, unsigned char * rowbuffer, int start);
 static int tds_bcp_add_variable_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data, tds_bcp_null_error null_error, int offset, TDS_UCHAR *rowbuffer, int start, int *pncols);
 
@@ -223,7 +225,7 @@ tds_build_bulk_insert_stmt(TDSSOCKET * tds, TDSPBCB * clause, TDSCOLUMN * bcpcol
 	return TDS_SUCCEED;
 }
 
-int
+static int
 tds_bcp_start_insert_stmt(TDSSOCKET * tds, TDSBCPINFO * bcpinfo)
 {
 	char *query;
@@ -699,7 +701,7 @@ tds_bcp_add_variable_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_d
 /** 
  * \return TDS_SUCCEED or TDS_FAIL.
  */
-int
+static int
 tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 {
 	const static unsigned char colmetadata_token = 0x81;
@@ -783,3 +785,197 @@ tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 
 	return TDS_SUCCEED;
 }
+
+int
+tds_bcp_done(TDSSOCKET *tds, int *rows_copied)
+{
+	tdsdump_log(TDS_DBG_FUNC, "tds_bcp_done(%p, %p)\n", tds, rows_copied);
+
+	/* TODO check proper tds state */
+	tds_flush_packet(tds);
+
+	tds_set_state(tds, TDS_PENDING);
+
+	if (tds_process_simple_query(tds) != TDS_SUCCEED)
+		return TDS_FAIL;
+
+	if (rows_copied)
+		*rows_copied = tds->rows_affected;
+
+	return TDS_SUCCEED;
+}
+
+int
+tds_bcp_start(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
+{
+	tdsdump_log(TDS_DBG_FUNC, "tds_bcp_start(%p, %p)\n", tds, bcpinfo);
+
+	tds_submit_query(tds, bcpinfo->insert_stmt);
+
+	if (tds_process_simple_query(tds) != TDS_SUCCEED)
+		return TDS_FAIL;
+
+	/* TODO problem with thread safety */
+	tds->out_flag = TDS_BULK;
+	tds_set_state(tds, TDS_QUERYING);
+
+	if (IS_TDS7_PLUS(tds))
+		tds_bcp_send_colmetadata(tds, bcpinfo);
+	
+	return TDS_SUCCEED;
+}
+
+static void 
+tds_bcp_row_free(TDSRESULTINFO* result, unsigned char *row)
+{
+	result->row_size = 0;
+	TDS_ZERO_FREE(result->current_row);
+}
+
+int
+tds_bcp_start_copy_in(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
+{
+	TDSCOLUMN *bcpcol;
+	int i;
+	int fixed_col_len_tot     = 0;
+	int variable_col_len_tot  = 0;
+	int column_bcp_data_size  = 0;
+	int bcp_record_size       = 0;
+	
+	tdsdump_log(TDS_DBG_FUNC, "tds_bcp_start_copy_in(%p, %p)\n", tds, bcpinfo);
+
+	if (tds_bcp_start_insert_stmt(tds, bcpinfo) == TDS_FAIL)
+		return TDS_FAIL;
+
+	/*
+	 * In TDS 5 we get the column information as a result set from the "insert bulk" command.
+	 * We're going to ignore it.  
+	 */
+	if (tds_process_simple_query(tds) != TDS_SUCCEED) {
+		/* TODO, in CTLib was _ctclient_msg(blkdesc->con, "blk_rowxfer", 2, 5, 1, 140, ""); */
+		return TDS_FAIL;
+	}
+
+	/* 
+	 * Work out the number of "variable" columns.  These are either nullable or of 
+	 * varying length type e.g. varchar.   
+	 */
+	bcpinfo->var_cols = 0;
+
+	if (IS_TDS50(tds)) {
+		for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
+	
+			bcpcol = bcpinfo->bindinfo->columns[i];
+
+			/*
+			 * work out storage required for this datatype
+			 * blobs always require 16, numerics vary, the
+			 * rest can be taken from the server
+			 */
+
+			if (is_blob_type(bcpcol->on_server.column_type))
+				column_bcp_data_size  = 16;
+			else if (is_numeric_type(bcpcol->on_server.column_type))
+				column_bcp_data_size  = tds_numeric_bytes_per_prec[bcpcol->column_prec];
+			else
+				column_bcp_data_size  = bcpcol->column_size;
+
+			/*
+			 * now add that size into either fixed or variable
+			 * column totals...
+			 */
+
+			if (is_nullable_type(bcpcol->on_server.column_type) || bcpcol->column_nullable) {
+				bcpinfo->var_cols++;
+				variable_col_len_tot += column_bcp_data_size;
+			}
+			else {
+				fixed_col_len_tot += column_bcp_data_size;
+			}
+		}
+
+		/* this formula taken from sybase manual... */
+
+		bcp_record_size =  	4 +
+							fixed_col_len_tot +
+							variable_col_len_tot +
+							( (int)(variable_col_len_tot / 256 ) + 1 ) +
+							(bcpinfo->var_cols + 1) +
+							2;
+
+		tdsdump_log(TDS_DBG_FUNC, "current_record_size = %d\n", bcpinfo->bindinfo->row_size);
+		tdsdump_log(TDS_DBG_FUNC, "bcp_record_size     = %d\n", bcp_record_size);
+
+		if (bcp_record_size > bcpinfo->bindinfo->row_size) {
+			/* FIXME remove memory leak */
+			bcpinfo->bindinfo->current_row = realloc(bcpinfo->bindinfo->current_row, bcp_record_size);
+			bcpinfo->bindinfo->row_free = tds_bcp_row_free;
+			if (bcpinfo->bindinfo->current_row == NULL) {
+				tdsdump_log(TDS_DBG_FUNC, "could not realloc current_row\n");
+				return TDS_FAIL;
+			}
+			bcpinfo->bindinfo->row_size = bcp_record_size;
+		}
+	}
+	if (IS_TDS7_PLUS(tds)) {
+		for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
+	
+			bcpcol = bcpinfo->bindinfo->columns[i];
+
+			/*
+			 * dont send the (meta)data for timestamp columns, or
+			 * identity columns (unless indentity_insert is enabled
+			 */
+
+			if ((!bcpinfo->identity_insert_on && bcpcol->column_identity) || 
+				bcpcol->column_timestamp) {
+				continue;
+			}
+
+			switch (bcpcol->column_varint_size) {
+				case 4:
+					if (is_blob_type(bcpcol->column_type)) {
+						bcp_record_size += 25;
+					}
+					bcp_record_size += 4;
+					break;
+				case 2:
+					bcp_record_size +=2;
+					break;
+				case 1:
+					bcp_record_size++;
+					break;
+				case 0:
+					break;
+			}
+
+			if (is_numeric_type(bcpcol->column_type)) {
+				bcp_record_size += tds_numeric_bytes_per_prec[bcpcol->column_prec];
+			} else {
+				bcp_record_size += bcpcol->column_size;
+			}
+		}
+		tdsdump_log(TDS_DBG_FUNC, "current_record_size = %d\n", bcpinfo->bindinfo->row_size);
+		tdsdump_log(TDS_DBG_FUNC, "bcp_record_size     = %d\n", bcp_record_size);
+
+		if (bcp_record_size > bcpinfo->bindinfo->row_size) {
+			bcpinfo->bindinfo->current_row = realloc(bcpinfo->bindinfo->current_row, bcp_record_size);
+			bcpinfo->bindinfo->row_free = tds_bcp_row_free;
+			if (bcpinfo->bindinfo->current_row == NULL) {
+				tdsdump_log(TDS_DBG_FUNC, "could not realloc current_row\n");
+				return TDS_FAIL;
+			}
+			bcpinfo->bindinfo->row_size = bcp_record_size;
+		}
+	}
+
+	/* set packet type to send bulk data */
+	tds->out_flag = TDS_BULK;
+	/* FIXME find a better way, some other thread could change state here */
+	tds_set_state(tds, TDS_QUERYING);
+
+	if (IS_TDS7_PLUS(tds))
+		tds_bcp_send_colmetadata(tds, bcpinfo);
+
+	return TDS_SUCCEED;
+}

